#include "HMG.CH"

#define WM_DROPFILES    0x0233

#command SET EVENTS FUNCTION TO <fname> [ RESULT TO <lSuccess> ] ;
=> ;
[ <lSuccess> := ] SetGlobalListener( <"fname"> )

MEMVAR hControl, _HMG_SYSDATA
PROCEDURE MAIN
LOCAL nIndex
PUBLIC hControl, _HMG_SYSDATA

DEFINE WINDOW DropDemo ;
   AT 0,0      ;
   WIDTH 550   ;
   HEIGHT 290  ;
   TITLE "Drop Demo" ;
   ICON "A1MAIN" ;
   ON INIT Nil ;
   NOSIZE   ;
   NOMAXIMIZE  ;
   NOMINIMIZE  ;
   MAIN

    DEFINE EDITBOX Drop_Edit
        ROW    20
        COL    20
        WIDTH  500
        HEIGHT 170
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        HSCROLLBAR .T.
        VSCROLLBAR .T.
    END EDITBOX

    DEFINE LABEL Label_1
        ROW    200
        COL    20
        WIDTH  500
        HEIGHT 30
        VALUE "drop some files from explorer to Control"
        FONTNAME "Arial"
        FONTSIZE 20
        VISIBLE .T.
        ACTION Nil
        CENTERALIGN .T.
    END LABEL

END WINDOW

// will show "+" drop sign
*   hControl := GetControlHandle( "Drop_Edit", "DropDemo" )
*   DragAcceptFiles( hControl, .t. )

// NEED this line
   DragAcceptFiles( DropDemo.HANDLE, .t. )

// this work with Window.Handle
   CREATE EVENT PROCNAME Drop_Detect() HWND DropDemo.HANDLE STOREINDEX nIndex
   EventProcessAllHookMessage( nIndex, .T. )

// MiniGUI Syntax
*   SET EVENTS FUNCTION TO MYEVENTS

   ON KEY ESCAPE OF DropDemo ACTION DropDemo.Release
   CENTER WINDOW DropDemo
   ACTIVATE WINDOW DropDemo

RETURN

FUNCTION Drop_Detect()
LOCAL nHWnd   := EventHWND()
LOCAL nMsg    := EventMSG()
LOCAL nWParam := EventWPARAM()
LOCAL nLParam := EventLPARAM()

   MyEvents ( nhWnd, nMsg, nwParam, nlParam )

RETURN NIL

Function MyEvents ( hWnd, nMsg, nwParam, nlParam )
LOCAL aFiles,nLen, i
LOCAL cText := ""

   DO CASE
      CASE nMsg == WM_DROPFILES
            MSGINFO( "WM_DROPFILES" )
ALTD()
            DropDemo.Drop_Edit.Value := ""
            aFiles := DragQueryFileS( nWParam )
            nLen := LEN( aFiles )
            FOR i := 1 TO nLen
               cText += aFiles[ i ] + CRLF
            NEXT
            DropDemo.Drop_Edit.Value := cText
   ENDCASE

RETURN Nil

*
*
*
