
#pragma BEGINDUMP

#include <Windows.h>
#include <ShellApi.h>
#include <hbapi.h>

/*
   Harbour MiniGUI 1.4 Extended (Build 47)
   added by Grigory Filatov
 */
HB_FUNC( DRAGACCEPTFILES )
{
   DragAcceptFiles( ( HWND ) hb_parnl( 1 ), hb_parl( 2 ) );
}

HB_FUNC( DRAGQUERYFILES )
{
   HDROP hDrop  = ( HDROP ) hb_parnl( 1 );
   int   iFiles = DragQueryFile( hDrop, 0xFFFFFFFF, 0, 0 );
   int   i;
   char  bBuffer[ 250 ];

   hb_reta( iFiles );

   for( i = 0; i < iFiles; i++ )
   {
      DragQueryFile( hDrop, i, ( char * ) bBuffer, 249 );
      hb_storvc( ( char * ) bBuffer, -1, i + 1 );
   }
}

HB_FUNC( DRAGFINISH )
{
   DragFinish( ( HDROP ) hb_parnl( 1 ) );
}

HB_FUNC( DRAGQUERYPOINT ) // ( hDrop, aPoint ) --> lInClient
{
   POINT pt;

   #ifndef _WIN64
      hb_retl( DragQueryPoint( ( HDROP ) hb_parnl( 1 ), &pt ) );
   #else
      hb_retl( DragQueryPoint( ( HDROP ) hb_parnll( 1 ), &pt ) );
   #endif

   hb_storvni( pt.x, 2, 1 );
   hb_storvni( pt.y, 2, 2 );
}


#pragma ENDDUMP
